Compare commits

..

51 Commits

Author SHA1 Message Date
mudler b34388c259 Merge branch 'dev' 2016-08-15 15:13:45 +02:00
mudler a1957a0587 [builder] fixes 2016-08-15 15:12:26 +02:00
mudler fcfb218a17 [builder] turn on split_install by default 2016-08-15 14:56:46 +02:00
mudler bac150a267 [builder] enhancing output 2016-08-15 14:48:18 +02:00
mudler 350e3d1000 [builder] split up into functions 2016-08-13 13:04:45 +02:00
mudler 10ef5244e3 [builder] allow to specify custom use flags per-package in the lists instead of in custom.use
* if emerge_split_install is enabled, then build.targets can contain useflags. (e.g. media-tv/kodi[-avahi] )
* for injected packages, this feature is always on
2016-08-13 12:40:36 +02:00
mudler 4b2cf1141c [sabayon-buildpackages] add support for ETP_NOCACHE 2016-08-04 11:25:21 +02:00
Ettore Di Giacinto 6e3ae4db29 builder: cleanup 2016-07-23 18:33:13 +02:00
Ettore Di Giacinto d3e174eb10 sabayon-buildpackages: add support for REMOTE_PORTDIR and REMOTE_CONF_PORTDIR 2016-07-23 18:30:43 +02:00
Ettore Di Giacinto 4c4279e707 builder: add support for remote portdir and portage configurations 2016-07-23 18:30:03 +02:00
mudler 0e33e0d75f builder: enable more verbosity to debug QA_CHECKS 2016-07-21 10:23:16 +02:00
mudler cd19f3b85b [builder] add equo args (multifetch && co.) 2016-07-21 10:20:06 +02:00
Ettore Di Giacinto b899a21852 [sabayon-buildpackages] support mounting of /etc/portage/env 2016-07-18 22:36:00 +02:00
Ettore Di Giacinto c9ad172bd4 [sabayon-buildpackages] mount packages.env instead populating packages.env/ 2016-07-18 22:26:33 +02:00
Ettore Di Giacinto cdac817e59 sabayondevkit-functions: trying softly to start docker daemon 2016-07-16 15:36:57 +02:00
Ettore Di Giacinto b33b4aa619 [builder] print qa checks if we are doing et 2016-07-16 10:27:54 +02:00
mudler c8cd58df4b [builder, sabayon-buildpackages] add QA_CHECKS env variable 2016-07-08 00:28:18 +02:00
Ettore Di Giacinto 44d7510792 [builder] removing append to make.conf, now the env variable is set and working also on the entropy side 2016-07-03 14:48:44 +02:00
Ettore Di Giacinto c7891958ea [functions] add --noreplace to default args 2016-05-28 12:56:52 +02:00
mudler c8a1ece37c [functions] build() and build_installed() echoing packages being installed 2016-05-28 12:33:09 +02:00
Ettore Di Giacinto fb745c8ed8 [builder] use ACCEPT_LICENSE with wildcard since Entropy 302 2016-05-26 12:17:07 +02:00
mudler 36fc5a6656 [sabayon-buildpackages] adding support for REMOVE_REMOTE_OVERLAY REMOVE_LAYMAN_OVERLAY 2016-05-17 19:31:52 +02:00
mudler a65f1acdca [builder] add support for REMOVE_REMOTE_OVERLAY and REMOVE_LAYMAN_OVERLAY 2016-05-17 19:30:40 +02:00
mudler 02fd49a321 [builder] better output for logs 2016-05-17 19:23:27 +02:00
mudler 868dfb767d [builder] clone user defined local_portage only if dir exists 2016-05-17 19:20:20 +02:00
mudler 5855d12d75 [builder] allow to pass to remote overlay the name and the sync-type 2016-05-17 19:18:24 +02:00
mudler 44aa54b031 [builder] removing dots from repository name 2016-05-16 11:12:02 +02:00
mudler 6bcf4abfee [builder] changing namespace allocation 2016-05-16 00:18:34 +02:00
mudler 31d3bca34b [builder] guessing sync_type from url 2016-05-13 22:45:30 +02:00
mudler 869f6a4363 [builder] url must be given in absolute form 2016-05-13 22:12:21 +02:00
mudler 3709d50006 [builder] default masters = gentoo https://github.com/Sabayon/community-buildspec/issues/9 2016-05-13 21:59:05 +02:00
mudler 939acad797 [builder] fixes and enhancement to add_portage_repository() https://github.com/Sabayon/community-buildspec/issues/9 2016-05-13 21:56:09 +02:00
mudler d9042cc4b5 [sabayon-buildpackages] TEMPDIR now is useless https://github.com/Sabayon/community-buildspec/issues/9 2016-05-12 12:16:30 +02:00
mudler 64d7085cb6 [builder/sabayon-buildpackages] passing REMOTE_OVERLAY to builder and adding repos as listed https://github.com/Sabayon/community-buildspec/issues/9 2016-05-12 12:09:44 +02:00
mudler 795aab5d24 [builder] don't re-add the repository if already there, sync instead. name of overlay now will be in the form namespace-name https://github.com/Sabayon/community-buildspec/issues/9 2016-05-12 12:04:34 +02:00
mudler b57f8905fe [builder] adding add_portage_repository() https://github.com/Sabayon/community-buildspec/issues/9 2016-05-12 11:58:14 +02:00
mudler 93a1093560 [builder] set ETP_NONINTERACTIVE to 1 2016-05-11 10:43:30 +02:00
mudler 84e62c332b [builder/buildpackages] adding EMERGE_REMOVE env 2016-05-10 11:40:08 +02:00
mudler 4430495086 [builder] printing what package we are compiling 2016-05-09 10:25:02 +02:00
mudler 70a7542692 [builder] remove workaround no longer needed 2016-05-03 23:55:27 +02:00
Ettore Di Giacinto 8aed3a00fa [builder] ENMAN_ADD_SELF defaults to 0 2016-05-03 10:47:29 +02:00
mudler 35f27e7b3b [builder/buildpackages] adding REMOVE_ENMAN_REPOSITORIES 2016-05-02 14:11:50 +02:00
Ettore Di Giacinto 6b1d8377b6 Update README.md 2016-04-30 14:33:34 +02:00
mudler db91098e92 [sabayon-createrepo-*] fixup typo 2016-04-22 17:42:35 +02:00
mudler 6fcccf99b8 [builder] do not check if string is contained in append_to_file if doesn't exists 2016-04-22 11:13:34 +02:00
mudler 67781838d3 [builder/sabayon-buildpackages] safe copy /usr/local/portage 2016-04-21 22:01:22 +02:00
mudler 69d8e28ac1 [builder] fixing permissions on local overlay 2016-04-21 21:52:41 +02:00
mudler b491ffccae [builder] check if the content is already there before appending content to file 2016-04-21 21:30:09 +02:00
mudler 066fb07d72 [builder] typo fixes 2016-04-17 19:47:01 +02:00
mudler c89721ab2e [builder] dropping equo (un)mask call, writing directly to packages.(un)mask files 2016-04-16 16:20:28 +02:00
mudler ea3d87a48a [sabayon-createrepo-*] adding gpg key support 2016-04-14 23:28:25 +02:00
6 changed files with 249 additions and 62 deletions
+3 -1
View File
@@ -11,7 +11,7 @@ sudo equo i sabayon-devkit
## Prerequisites ## Prerequisites
* docker installed in the machine (`sudo equo i docker`), and the daemon started (`sudo systemctl start docker`) * docker installed in the machine (`sudo equo i docker`), and the daemon started (`sudo systemctl start docker`)
* if you don't want to run that as root, the user where are you running the script must be in the docker group (`sudo gpasswd -a $USER docker`) * if you don't want to run that as root, the user where are you running the script must be in the docker group (`sudo gpasswd -a $USER docker`), or granting permission to yourself adding your user to the sudoer file.
Packages can be built in a clean environment with docker by running `sabayon-buildpackages`. Packages can be built in a clean environment with docker by running `sabayon-buildpackages`.
@@ -92,6 +92,8 @@ you can override the Architecture folder in which files are placed specifying in
- DOCKER_PULL_IMAGE -- tells the script to update the docker image before compiling, enable it with 1, disable with 0 - DOCKER_PULL_IMAGE -- tells the script to update the docker image before compiling, enable it with 1, disable with 0
- OUTPUT_DIR -- optional, default to "portage_artifacts" in your current working directory, it is the path where emerge generated tbz2 are stored (absolute path) - OUTPUT_DIR -- optional, default to "portage_artifacts" in your current working directory, it is the path where emerge generated tbz2 are stored (absolute path)
- LOCAL_OVERLAY -- optional, you can specify the path to your local overlay (absolute path) - LOCAL_OVERLAY -- optional, you can specify the path to your local overlay (absolute path)
- REMOTE_OVERLAY -- optional, a space separated list of overlays that can be cloned with git.
The arguments are the packages that you want compile, they can be also in the complete form *e.g. =foo-bar/misc-1.2* The arguments are the packages that you want compile, they can be also in the complete form *e.g. =foo-bar/misc-1.2*
+217 -39
View File
@@ -15,22 +15,31 @@ $ENV{FEATURES} = $ENV{FEATURES}
my $equo_install_atoms = $ENV{EQUO_INSTALL_ATOMS} // 1; my $equo_install_atoms = $ENV{EQUO_INSTALL_ATOMS} // 1;
my $equo_install_version = $ENV{EQUO_INSTALL_VERSION} // 0; my $equo_install_version = $ENV{EQUO_INSTALL_VERSION} // 0;
my $equo_split_install = $ENV{EQUO_SPLIT_INSTALL} // 0; my $equo_split_install = $ENV{EQUO_SPLIT_INSTALL} // 1;
my $equo_mirrorsort = $ENV{EQUO_MIRRORSORT} // 1; my $equo_mirrorsort = $ENV{EQUO_MIRRORSORT} // 1;
my $entropy_repository = $ENV{ENTROPY_REPOSITORY} my $entropy_repository = $ENV{ENTROPY_REPOSITORY}
// "main"; # Can be weekly, main, testing // "main"; # Can be weekly, main, testing
my $artifacts_folder = $ENV{ARTIFACTS_DIR}; my $artifacts_folder = $ENV{ARTIFACTS_DIR};
my $dep_scan_depth = $ENV{DEPENDENCY_SCAN_DEPTH} // 2; my $dep_scan_depth = $ENV{DEPENDENCY_SCAN_DEPTH} // 2;
my $skip_portage_sync = $ENV{SKIP_PORTAGE_SYNC} // 0; my $skip_portage_sync = $ENV{SKIP_PORTAGE_SYNC} // 0;
my $emerge_split_install = $ENV{EMERGE_SPLIT_INSTALL} // 0; my $emerge_split_install = $ENV{EMERGE_SPLIT_INSTALL} // 0;
my $webrsync = $ENV{WEBRSYNC} // 0; my $webrsync = $ENV{WEBRSYNC} // 0;
my $enman_repositories = $ENV{ENMAN_REPOSITORIES}; my $enman_repositories = $ENV{ENMAN_REPOSITORIES};
my $prune_virtuals = $ENV{PRUNE_VIRTUALS} // 0; my $emerge_remove = $ENV{EMERGE_REMOVE};
my $repository_name = $ENV{REPOSITORY_NAME}; my $remove_enman_repositories = $ENV{REMOVE_ENMAN_REPOSITORIES};
my $enman_add_self = $ENV{ENMAN_ADD_SELF} // 1; my $remove_remote_overlay = $ENV{REMOVE_REMOTE_OVERLAY};
my $build_injected_args = $ENV{BUILD_INJECTED_ARGS}; my $remove_layman_overlay = $ENV{REMOVE_LAYMAN_OVERLAY};
my $equo_masks = $ENV{EQUO_MASKS}; my $prune_virtuals = $ENV{PRUNE_VIRTUALS} // 0;
my $equo_unmasks = $ENV{EQUO_UNMASKS}; my $repository_name = $ENV{REPOSITORY_NAME};
my $enman_add_self = $ENV{ENMAN_ADD_SELF} // 0;
my $build_injected_args = $ENV{BUILD_INJECTED_ARGS};
my $equo_masks = $ENV{EQUO_MASKS};
my $equo_unmasks = $ENV{EQUO_UNMASKS};
my $equo_install_args = $ENV{EQUO_INSTALL_ARGS} // "--multifetch=10";
my $remote_overlay = $ENV{REMOTE_OVERLAY};
my $repoman_check = $ENV{QA_CHECKS} // 0;
my $remote_conf_portdir = $ENV{REMOTE_CONF_PORTDIR};
my $remote_portdir = $ENV{REMOTE_PORTDIR};
my $make_conf = $ENV{MAKE_CONF}; my $make_conf = $ENV{MAKE_CONF};
@@ -45,7 +54,9 @@ GetOptions(
help() if $help; help() if $help;
$ENV{LC_ALL} = "en_US.UTF-8"; #here be dragons $ENV{LC_ALL} = "en_US.UTF-8"; #here be dragons
$ENV{ETP_NONINTERACTIVE} = 1;
$ENV{ACCEPT_LICENSE} = "*"; # we can use wildcard since entropy 302
# A barely print replacement # A barely print replacement
sub say { print join( "\n", @_ ) . "\n"; } sub say { print join( "\n", @_ ) . "\n"; }
@@ -57,6 +68,60 @@ sub safe_call {
exit($return) if ($rt); exit($return) if ($rt);
} }
sub append_to_file {
my ( $file_name, $package ) = @_;
if ( -f $file_name ) {
# Check that the package was not already there
open my $fh_ro, '<:encoding(UTF-8)', $file_name
or die("Cannot open: $file_name");
while ( my $line = <$fh_ro> ) {
return if $line eq $package . "\n";
}
close $fh_ro;
}
open( my $fh_a, '>>', $file_name )
or die "Could not open file '$filename' $!";
print $fh_a $package . "\n";
close $fh_a;
}
sub add_portage_repository {
my $repo = $_[0];
my $reponame;
my $sync_type;
my @repodef = split( /\|/, $repo );
( $reponame, $repo ) = @repodef if ( @repodef == 2 );
( $reponame, $sync_type, $repo ) = @repodef if ( @repodef == 3 );
# try to detect sync-type
if ( !$sync_type ) {
$sync_type = ( split( /\:/, $repo ) )[0];
$sync_type = "git"
if $repo =~ /github|bitbucket/
or $sync_type eq "https"
or $sync_type eq "http";
$sync_type = "svn" if $repo =~ /\/svn\//;
}
$reponame = ( split( /\//, $repo ) )[-1] if !$reponame;
$reponame =~ s/\.|//g; #clean
system("mkdir -p /etc/portage/repos.conf/")
if ( !-d "/etc/portage/repos.conf/" );
say "==== Adding $reponame ====";
qx{
echo '[$reponame]
location = /usr/local/overlay/$reponame
sync-type = $sync_type
sync-uri = $repo
auto-sync = yes' > /etc/portage/repos.conf/$reponame.conf
}; # Declaring the repo and giving priority
system("emaint sync -r $reponame");
}
# Input: package, depth, and atom. Package: sys-fs/foobarfs, Depth: 1 (depth of the package tree) , Atom: 1/0 (enable disable atom output) # Input: package, depth, and atom. Package: sys-fs/foobarfs, Depth: 1 (depth of the package tree) , Atom: 1/0 (enable disable atom output)
sub package_deps { sub package_deps {
my $package = shift; my $package = shift;
@@ -154,6 +219,54 @@ sub uniq {
keys %{ { map { $_ => 1 } @_ } }; keys %{ { map { $_ => 1 } @_ } };
} }
sub detect_useflags
{ # Detect useflags defined as [-alsa,avahi] in atom, and fill $hash within the $target sub-hash
my ( $target, $packages ) = @_;
my @packs = @{$packages};
for my $i ( 0 .. $#packs ) {
if ( $packages->[$i] =~ /\[(.*?)\]/ ) {
my $flags = $1;
$packages->[$i] =~ s/\[.*?\]//g;
$per_package_useflags->{$target}->[$i] = [ +split( /,/, $flags ) ];
}
}
}
sub compile_packs {
my ( $target, @packages ) = @_;
my $extra_arg;
$extra_arg = "-B" if $target eq "injected_targets";
my $package_counter = 0;
my $return;
for my $pack (@packages) {
my $tmp_rt;
say "\n" x 2, "==== Compiling $pack ====", "\n" x 2;
if ( defined $per_package_useflags->{$target}->[$package_counter]
and @{ $per_package_useflags->{$target}->[$package_counter] } > 0 )
{
say "USEFLAGS: "
. join( " ",
@{ $per_package_useflags->{$target}->[$package_counter] } );
$tmp_rt = system(
"USE=\""
. join( " ",
@{ $per_package_useflags->{$target}->[$package_counter] } )
. "\" emerge $emerge_defaults_args -j $jobs $extra_arg $pack"
);
}
else {
$tmp_rt =
system("emerge $emerge_defaults_args -j $jobs $extra_arg $pack");
}
$package_counter++;
$return = $tmp_rt
if ( $? == -1 or $? & 127 or !$rt )
; # if one fails, the build should be considered failed!
}
return $return;
}
sub help { sub help {
say "-> You should feed me with something", "", "Examples:", "", say "-> You should feed me with something", "", "Examples:", "",
"\t$0 app-text/tree", "\t$0 plasma-meta --layman kde", "", "\t$0 app-text/tree", "\t$0 plasma-meta --layman kde", "",
@@ -182,11 +295,24 @@ say "[*] Syncing configurations files, Layman and Portage";
# Syncronizing portage configuration and adding overlays # Syncronizing portage configuration and adding overlays
system("echo 'en_US.UTF-8 UTF-8' > /etc/locale.gen"); #be sure about that. system("echo 'en_US.UTF-8 UTF-8' > /etc/locale.gen"); #be sure about that.
system("cd /etc/portage/;git checkout master; git stash; git pull");
if ( `uname -m` eq "x86_64\n" ) { # If defined, fetch a remote /etc/portage
system( if ( $remote_conf_portdir ne "" ) {
"cd /etc/portage/;rm -rfv make.conf;ln -s make.conf.amd64 make.conf"); system("rm -rf /etc/portage");
system("git clone $remote_conf_portdir /etc/portage");
system("chown -R portage:portage /etc/portage");
system("chmod -R ug+w,a+rX /etc/portage");
}
else {
system("cd /etc/portage/;git checkout master; git stash; git pull");
}
# If defined, fetch a remote /usr/portage
if ( $remote_portdir ne "" ) {
system("rm -rf /usr/portage");
system("git clone $remote_portdir /usr/portage");
system("chown -R portage:portage /usr/portage");
system("chmod -R ug+w,a+rX /usr/portage");
} }
system("echo 'y' | layman -f -a $_") for @overlays; system("echo 'y' | layman -f -a $_") for @overlays;
@@ -194,11 +320,14 @@ system("echo 'y' | layman -f -a $_") for @overlays;
my $reponame = "LocalOverlay"; my $reponame = "LocalOverlay";
# Setting up a local overlay if doesn't exists # Setting up a local overlay if doesn't exists
system(
"rm -rf /usr/local/portage;cp -rf /usr/local/local_portage /usr/local/portage"
) if ( -d "/usr/local/local_portage" );
if ( !-f "/usr/local/portage/profiles/repo_name" ) { if ( !-f "/usr/local/portage/profiles/repo_name" ) {
system("mkdir -p /usr/local/portage/{metadata,profiles}"); system("mkdir -p /usr/local/portage/{metadata,profiles}");
system("echo 'LocalOverlay' > /usr/local/portage/profiles/repo_name"); system("echo 'LocalOverlay' > /usr/local/portage/profiles/repo_name");
system("echo 'masters = gentoo' > /usr/local/portage/metadata/layout.conf"); system("echo 'masters = gentoo' > /usr/local/portage/metadata/layout.conf");
system("chown -R portage:portage /usr/local/portage");
} }
else { else {
open FILE, "</usr/local/portage/profiles/repo_name"; open FILE, "</usr/local/portage/profiles/repo_name";
@@ -207,6 +336,8 @@ else {
chomp(@FILE); chomp(@FILE);
$reponame = $FILE[0]; $reponame = $FILE[0];
} }
system("chown -R portage:portage /usr/local/portage");
system("chmod -R 755 /usr/local/portage");
qx{ qx{
echo '[$reponame] echo '[$reponame]
@@ -216,6 +347,21 @@ priority=9999
auto-sync = no' > /etc/portage/repos.conf/local.conf auto-sync = no' > /etc/portage/repos.conf/local.conf
}; # Declaring the repo and giving priority }; # Declaring the repo and giving priority
if ( $remote_overlay and $remote_overlay ne "" ) {
add_portage_repository($_) for ( split( / /, $remote_overlay ) );
}
if ( $remove_layman_overlay and $remove_layman_overlay ne "" ) {
say "===== Removing overlays: $remove_remote_overlay =====";
system("layman -d $_") for ( split( / /, $remove_layman_overlay ) );
}
if ( $remove_remote_overlay and $remove_remote_overlay ne "" ) {
say "===== Removing overlays: $remove_remote_overlay =====";
system( "rm -rfv /etc/portage/" . $_ . ".conf" )
for ( split( / /, $remote_overlay ) );
}
system("mkdir -p /usr/portage/distfiles/git3-src"); system("mkdir -p /usr/portage/distfiles/git3-src");
unless ( $skip_portage_sync == 1 ) { unless ( $skip_portage_sync == 1 ) {
@@ -232,8 +378,6 @@ unless ( $skip_portage_sync == 1 ) {
# preparing for MOAR automation # preparing for MOAR automation
qx|eselect profile set $profile|; qx|eselect profile set $profile|;
qx{ls /usr/portage/licenses -1 | xargs -0 > /etc/entropy/packages/license.accept}
; #HAHA
if ( $use_equo && $entropy_repository eq "weekly" ) { if ( $use_equo && $entropy_repository eq "weekly" ) {
qx|equo repo disable sabayonlinux.org|; qx|equo repo disable sabayonlinux.org|;
@@ -246,11 +390,20 @@ elsif ( $use_equo && $entropy_repository eq "testing" ) {
} }
if ($use_equo) { if ($use_equo) {
say "Devkit version:";
system("equo s -vq app-misc/sabayon-devkit");
if ( $enman_repositories and $enman_repositories ne "" ) { if ( $enman_repositories and $enman_repositories ne "" ) {
my @enman_toadd = split( / /, $enman_repositories ); my @enman_toadd = split( / /, $enman_repositories );
safe_call("enman add $_") for @enman_toadd; safe_call("enman add $_") for @enman_toadd;
} }
if ( $remove_enman_repositories and $remove_enman_repositories ne "" ) {
my @enman_toremove = split( / /, $remove_enman_repositories );
system("enman remove $_") for @enman_toremove;
}
system("enman add $repository_name") system("enman add $repository_name")
if ( $enman_add_self and $repository_name and $repository_name ne "" ); if ( $enman_add_self and $repository_name and $repository_name ne "" );
system("equo repo mirrorsort sabayonlinux.org") if $equo_mirrorsort; system("equo repo mirrorsort sabayonlinux.org") if $equo_mirrorsort;
@@ -259,20 +412,41 @@ if ($use_equo) {
system("cp -rf $make_conf /etc/portage/make.conf") if $make_conf; system("cp -rf $make_conf /etc/portage/make.conf") if $make_conf;
qx|echo 'ACCEPT_LICENSE="*"' >> /etc/portage/make.conf|; #just plain evil my $per_package_useflags;
my @packages = @ARGV;
my @injected_packages = ();
if ($build_injected_args) {
@injected_packages = split( / /, $build_injected_args );
say "[*] Injected installs:";
my @packages = @ARGV; say "\t* " . $_ for @injected_packages;
}
# Allow users to specify atoms as: media-tv/kodi[-alsa,avahi]
if ($emerge_split_install)
{ # For targets this will be available only if split_install is enabled
detect_useflags( "targets", \@packages );
}
else {
map { $_ =~ s/\[.*?\]//g; $_; }
@packages
; # Clean up [] if user didn't specified split_install, but specified a useflag combination
}
detect_useflags( "injected_targets", \@injected_packages );
if ($use_equo) { if ($use_equo) {
# best effort mask # best effort mask
if ($equo_masks) { if ($equo_masks) {
system("equo mask $_") for ( split( / /, $equo_masks ) ); append_to_file( "/etc/entropy/packages/package.mask", $_ )
for ( split( / /, $equo_masks ) );
} }
# best effort unmask # best effort unmask
if ($equo_unmasks) { if ($equo_unmasks) {
system("equo unmask $_") for ( split( / /, $equo_unmasks ) ); append_to_file( "/etc/entropy/packages/package.unmask", $_ )
for ( split( / /, $equo_unmasks ) );
} }
my @packages_deps; my @packages_deps;
@@ -304,7 +478,7 @@ if ($use_equo) {
say "", "[install] Those dependencies will be installed with equo :", say "", "[install] Those dependencies will be installed with equo :",
@packages_deps, ""; @packages_deps, "";
if ($equo_split_install) { if ($equo_split_install) {
safe_call("equo i --bdeps $_") safe_call("equo i $equo_install_args --bdeps $_")
for ( @packages_deps, @equo_install ) for ( @packages_deps, @equo_install )
; ## bail out here, if installs fails. emerge will compile a LOT of stuff ; ## bail out here, if installs fails. emerge will compile a LOT of stuff
if ( @equo_remove > 0 ) { if ( @equo_remove > 0 ) {
@@ -312,29 +486,36 @@ if ($use_equo) {
} }
} }
else { else {
safe_call("equo i --bdeps @packages_deps @equo_install") safe_call(
"equo i $equo_install_args --bdeps @packages_deps @equo_install")
if ( @packages_deps > 0 or @equo_install > 0 ) if ( @packages_deps > 0 or @equo_install > 0 )
; ## bail out here, if installs fails. emerge will compile a LOT of stuff ; ## bail out here, if installs fails. emerge will compile a LOT of stuff
system("equo rm --nodeps @equo_remove") if ( @equo_remove > 0 ); system("equo rm --nodeps @equo_remove") if ( @equo_remove > 0 );
} }
} }
if ( $repoman_check == 1 ) {
say "*** Repoman checks ***";
for ( @packages, @injected_packages ) {
say "*** QA checks for $_";
system(
"pushd \$(dirname \$(equery which $_ 2>/dev/null)); repoman; popd");
}
}
say "*** Ready to compile, finger crossed ***"; say "*** Ready to compile, finger crossed ***";
system("emerge --info") system("emerge --info")
; #always give detailed information about the building environment, helpful to debug ; #always give detailed information about the building environment, helpful to debug
say "Devkit version:";
system("equo s -vq app-misc/sabayon-devkit");
my $rt; my $rt;
if ($emerge_split_install) { if ( $emerge_remove and $emerge_remove ne "" ) {
for my $pack (@packages) { system("emerge -C $_") for split( / /, $emerge_remove );
my $tmp_rt = system("emerge $emerge_defaults_args -j $jobs $pack"); }
# $rt=$tmp_rt if ($? == -1 or $? & 127 or !$rt); # if one fails, the build should be considered failed! if ($emerge_split_install) {
} compile_packs( "targets", @packages );
$rt = 0; #consider the build good anyway, like a "keep-going" $rt = 0; #consider the build good anyway, like a "keep-going"
} }
else { else {
@@ -344,10 +525,7 @@ else {
my $return = $rt >> 8; my $return = $rt >> 8;
# best effort -B # best effort -B
if ($build_injected_args) { compile_packs( "injected_targets", @injected_packages );
system("emerge $emerge_defaults_args -j $jobs -B $_")
for ( split( / /, $build_injected_args ) );
}
if ($preserved_rebuild) { if ($preserved_rebuild) {
+12 -15
View File
@@ -9,7 +9,6 @@ OUTPUT_DIR="${OUTPUT_DIR:-$SAB_WORKSPACE/portage_artifacts/}"
LOCAL_OVERLAY="${LOCAL_OVERLAY:-$SAB_WORKSPACE/local_overlay}" LOCAL_OVERLAY="${LOCAL_OVERLAY:-$SAB_WORKSPACE/local_overlay}"
ENTROPY_REPOSITORY="${ENTROPY_REPOSITORY:-main}" # Can be weekly, main, testing ENTROPY_REPOSITORY="${ENTROPY_REPOSITORY:-main}" # Can be weekly, main, testing
DOCKER_OPTS="${DOCKER_OPTS:--ti --rm}" DOCKER_OPTS="${DOCKER_OPTS:--ti --rm}"
TEMPDIR=$(mktemp -d)
. /sbin/sabayondevkit-functions.sh . /sbin/sabayondevkit-functions.sh
@@ -40,6 +39,7 @@ docker_volumes=( -v "$OUTPUT_DIR:/usr/portage/packages" )
[ -z "$EQUO_MIRRORSORT" ] || docker_env+=(-e "EQUO_MIRRORSORT=$EQUO_MIRRORSORT") [ -z "$EQUO_MIRRORSORT" ] || docker_env+=(-e "EQUO_MIRRORSORT=$EQUO_MIRRORSORT")
[ -z "$WEBRSYNC" ] || docker_env+=(-e "WEBRSYNC=$WEBRSYNC") [ -z "$WEBRSYNC" ] || docker_env+=(-e "WEBRSYNC=$WEBRSYNC")
[ -z "$ENMAN_REPOSITORIES" ] || docker_env+=(-e "ENMAN_REPOSITORIES=$ENMAN_REPOSITORIES") [ -z "$ENMAN_REPOSITORIES" ] || docker_env+=(-e "ENMAN_REPOSITORIES=$ENMAN_REPOSITORIES")
[ -z "$REMOVE_ENMAN_REPOSITORIES" ] || docker_env+=(-e "REMOVE_ENMAN_REPOSITORIES=$REMOVE_ENMAN_REPOSITORIES")
[ -z "$DISTFILES" ] || docker_volumes+=(-v "$DISTFILES:/usr/portage/distfiles") [ -z "$DISTFILES" ] || docker_volumes+=(-v "$DISTFILES:/usr/portage/distfiles")
[ -z "$ENTROPY_DOWNLOADED_PACKAGES" ] || docker_volumes+=(-v "$ENTROPY_DOWNLOADED_PACKAGES:/var/lib/entropy/client/packages") [ -z "$ENTROPY_DOWNLOADED_PACKAGES" ] || docker_volumes+=(-v "$ENTROPY_DOWNLOADED_PACKAGES:/var/lib/entropy/client/packages")
[ -z "$DISTCC_HOSTS" ] || docker_env+=(-e "DISTCC_HOSTS=$DISTCC_HOSTS") [ -z "$DISTCC_HOSTS" ] || docker_env+=(-e "DISTCC_HOSTS=$DISTCC_HOSTS")
@@ -48,19 +48,15 @@ docker_volumes=( -v "$OUTPUT_DIR:/usr/portage/packages" )
[ -z "$ENMAN_ADD_SELF" ] || docker_env+=(-e "ENMAN_ADD_SELF=$ENMAN_ADD_SELF") [ -z "$ENMAN_ADD_SELF" ] || docker_env+=(-e "ENMAN_ADD_SELF=$ENMAN_ADD_SELF")
[ -z "$EQUO_MASKS" ] || docker_env+=(-e "EQUO_MASKS=$EQUO_MASKS") [ -z "$EQUO_MASKS" ] || docker_env+=(-e "EQUO_MASKS=$EQUO_MASKS")
[ -z "$EQUO_UNMASKS" ] || docker_env+=(-e "EQUO_UNMASKS=$EQUO_UNMASKS") [ -z "$EQUO_UNMASKS" ] || docker_env+=(-e "EQUO_UNMASKS=$EQUO_UNMASKS")
[ -z "$EMERGE_REMOVE" ] || docker_env+=(-e "EMERGE_REMOVE=$EMERGE_REMOVE")
if [ -n "$REMOTE_OVERLAY" ]; then [ -z "$REMOTE_OVERLAY" ] || docker_env+=(-e "REMOTE_OVERLAY=$REMOTE_OVERLAY")
git clone "$REMOTE_OVERLAY" "$TEMPDIR" [ -z "$REMOVE_LAYMAN_OVERLAY" ] || docker_env+=(-e "REMOVE_LAYMAN_OVERLAY=$REMOVE_LAYMAN_OVERLAY")
LOCAL_OVERLAY=$TEMPDIR [ -z "$REMOVE_REMOTE_OVERLAY" ] || docker_env+=(-e "REMOVE_REMOTE_OVERLAY=$REMOVE_REMOTE_OVERLAY")
fi [ -z "$QA_CHECKS" ] || docker_env+=(-e "QA_CHECKS=$QA_CHECKS")
[ -z "$REMOTE_CONF_PORTDIR" ] || docker_env+=(-e "REMOTE_CONF_PORTDIR=$REMOTE_CONF_PORTDIR")
function cleanup { [ -z "$REMOTE_PORTDIR" ] || docker_env+=(-e "REMOTE_PORTDIR=$REMOTE_PORTDIR")
rm -rf "$TEMPDIR" [ -z "$ETP_NOCACHE" ] || docker_env+=(-e "ETP_NOCACHE=$ETP_NOCACHE")
} [ -d "$LOCAL_OVERLAY" ] && docker_volumes+=(-v "$LOCAL_OVERLAY:/usr/local/local_portage")
trap cleanup EXIT
[ -d "$LOCAL_OVERLAY" ] && docker_volumes+=(-v "$LOCAL_OVERLAY:/usr/local/portage")
if [ -e $MAKE_CONF ]; then if [ -e $MAKE_CONF ]; then
echo "You specified a make.conf. I hope you know what are you doing" echo "You specified a make.conf. I hope you know what are you doing"
@@ -77,8 +73,9 @@ if [ -d "$SAB_WORKSPACE"/specs ]; then
[ -e "$SAB_WORKSPACE"/specs/custom.mask ] && docker_volumes+=(-v "$SAB_WORKSPACE/specs/custom.mask:/opt/sabayon-build/conf/$SAB_ARCH/portage/package.mask/99-custom.mask") [ -e "$SAB_WORKSPACE"/specs/custom.mask ] && docker_volumes+=(-v "$SAB_WORKSPACE/specs/custom.mask:/opt/sabayon-build/conf/$SAB_ARCH/portage/package.mask/99-custom.mask")
[ -e "$SAB_WORKSPACE"/specs/custom.unmask ] && docker_volumes+=(-v "$SAB_WORKSPACE/specs/custom.unmask:/opt/sabayon-build/conf/$SAB_ARCH/portage/package.unmask/99-custom.unmask") [ -e "$SAB_WORKSPACE"/specs/custom.unmask ] && docker_volumes+=(-v "$SAB_WORKSPACE/specs/custom.unmask:/opt/sabayon-build/conf/$SAB_ARCH/portage/package.unmask/99-custom.unmask")
[ -e "$SAB_WORKSPACE"/specs/custom.use ] && docker_volumes+=(-v "$SAB_WORKSPACE/specs/custom.use:/opt/sabayon-build/conf/$SAB_ARCH/portage/package.use/99-custom.use") [ -e "$SAB_WORKSPACE"/specs/custom.use ] && docker_volumes+=(-v "$SAB_WORKSPACE/specs/custom.use:/opt/sabayon-build/conf/$SAB_ARCH/portage/package.use/99-custom.use")
[ -e "$SAB_WORKSPACE"/specs/custom.env ] && docker_volumes+=(-v "$SAB_WORKSPACE/specs/custom.env:/opt/sabayon-build/conf/$SAB_ARCH/portage/package.env/99-custom.env") [ -e "$SAB_WORKSPACE"/specs/custom.env ] && docker_volumes+=(-v "$SAB_WORKSPACE/specs/custom.env:/opt/sabayon-build/conf/$SAB_ARCH/portage/package.env")
[ -e "$SAB_WORKSPACE"/specs/custom.keywords ] && docker_volumes+=(-v "$SAB_WORKSPACE/specs/custom.keywords:/opt/sabayon-build/conf/$SAB_ARCH/portage/package.keywords/99-custom.keywords") [ -e "$SAB_WORKSPACE"/specs/custom.keywords ] && docker_volumes+=(-v "$SAB_WORKSPACE/specs/custom.keywords:/opt/sabayon-build/conf/$SAB_ARCH/portage/package.keywords/99-custom.keywords")
[ -d "$SAB_WORKSPACE"/specs/env ] && docker_volumes+=(-v "$SAB_WORKSPACE/specs/env/:/opt/sabayon-build/conf/$SAB_ARCH/portage/env/")
fi fi
+6 -1
View File
@@ -25,6 +25,8 @@ docker_volumes=(
-v "$entropysrv:/etc/entropy/server.conf" -v "$entropysrv:/etc/entropy/server.conf"
-v "$PORTAGE_ARTIFACTS:/usr/portage/packages" ) -v "$PORTAGE_ARTIFACTS:/usr/portage/packages" )
[ -z "$PUBKEY" ] || docker_volumes+=(-v "$PUBKEY:/etc/entropy/mykeys/key.pub")
[ -z "$PRIVATEKEY" ] || docker_volumes+=(-v "$PRIVATEKEY:/etc/entropy/mykeys/private.key")
check_docker_requirements check_docker_requirements
@@ -40,12 +42,15 @@ repo="\${REPOSITORY:-default}"
if [ -d "/sabayon/artifacts/standard" ]; then if [ -d "/sabayon/artifacts/standard" ]; then
eit unlock \$repo || true eit unlock \$repo || true
eit pull --quick $repo || true eit pull --quick \$repo || true
#eit sync \$repo #eit sync \$repo
else else
echo "ouch no repository there" && exit 3; echo "ouch no repository there" && exit 3;
fi fi
[ -f "/etc/entropy/mykeys/key.pub" ] && [ -f "/etc/entropy/mykeys/private.key" ] && { ! eit key status \$repo; } && \
eit key import \$repo /etc/entropy/mykeys/private.key /etc/entropy/mykeys/key.pub && { eit key sign \$repo || true; } && { echo "=== Repository key imported successfully ==="; }
eit clean --quick || { echo "ouch unable to remove" && exit 3; } eit clean --quick || { echo "ouch unable to remove" && exit 3; }
eit vacuum --quick || { echo "ouch unable to remove" && exit 3; } eit vacuum --quick || { echo "ouch unable to remove" && exit 3; }
+6 -2
View File
@@ -24,7 +24,8 @@ docker_volumes=(
-v "$createrepo:/sabayon/bin/create_repo.sh" -v "$createrepo:/sabayon/bin/create_repo.sh"
-v "$entropysrv:/etc/entropy/server.conf" -v "$entropysrv:/etc/entropy/server.conf"
-v "$PORTAGE_ARTIFACTS:/usr/portage/packages" ) -v "$PORTAGE_ARTIFACTS:/usr/portage/packages" )
[ -z "$PUBKEY" ] || docker_volumes+=(-v "$PUBKEY:/etc/entropy/mykeys/key.pub")
[ -z "$PRIVATEKEY" ] || docker_volumes+=(-v "$PRIVATEKEY:/etc/entropy/mykeys/private.key")
check_docker_requirements check_docker_requirements
@@ -40,12 +41,15 @@ repo="\${REPOSITORY:-default}"
if [ -d "/sabayon/artifacts/standard" ]; then if [ -d "/sabayon/artifacts/standard" ]; then
eit unlock \$repo || true eit unlock \$repo || true
eit pull --quick $repo || true eit pull --quick \$repo || true
#eit sync \$repo #eit sync \$repo
else else
echo "ouch no repository there" && exit 3; echo "ouch no repository there" && exit 3;
fi fi
[ -f "/etc/entropy/mykeys/key.pub" ] && [ -f "/etc/entropy/mykeys/private.key" ] && { ! eit key status \$repo; } && \
eit key import \$repo /etc/entropy/mykeys/private.key /etc/entropy/mykeys/key.pub && { eit key sign \$repo || true; } && { echo "=== Repository key imported successfully ==="; }
echo "Yes" | eit rm --from \$repo ${args[@]} || { echo "ouch unable to remove" && exit 3; } echo "Yes" | eit rm --from \$repo ${args[@]} || { echo "ouch unable to remove" && exit 3; }
echo "Yes Yes Yes" | eit commit --quick echo "Yes Yes Yes" | eit commit --quick
eit push --quick --force eit push --quick --force
+5 -4
View File
@@ -4,16 +4,17 @@ check_docker_requirements(){
if [ "$(id -u)" != "0" ]; then if [ "$(id -u)" != "0" ]; then
groups | grep -q docker || echo "--> If you are not running the script as root, your user should be in the docker group to use it. (sudo gpasswd -a $USER docker)" groups | grep -q docker || echo "--> If you are not running the script as root, your user should be in the docker group to use it. (sudo gpasswd -a $USER docker)"
fi fi
ps aux | grep -q '[d]ocker' || echo "--> Be sure to have the docker daemon running (sudo systemctl start docker) of configure it to run on boot (sudo systemctl enable docker). Trying to start it anyway" && sudo systemctl start docker ps aux | grep -q '[d]ocker' || echo "--> Be sure to have the docker daemon running (sudo systemctl start docker) of configure it to run on boot (sudo systemctl enable docker). Trying to start it anyway" && sudo systemctl start docker || true
} }
die() { echo "$@" 1>&2 ; exit 1; } die() { echo "$@" 1>&2 ; exit 1; }
build() { build() {
local SEARCH=$1 local SEARCH=$1
local EMERGE_DEFAULT_ARGS=${2:---accept-properties=-interactive --verbose --oneshot --nospinner --quiet-build=y --quiet-fail --fail-clean=y --complete-graph --buildpkg} local EMERGE_DEFAULT_ARGS=${2:---accept-properties=-interactive --verbose --oneshot --nospinner --noreplace --quiet-build=y --quiet-fail --fail-clean=y --complete-graph --buildpkg}
for i in $(EIX_LIMIT=0 eix --only-names --pure-packages "$SEARCH/" | xargs echo | uniq); for i in $(EIX_LIMIT=0 eix --only-names --pure-packages "$SEARCH/" | xargs echo | uniq);
do do
echo "Building $i"
emerge $EMERGE_DEFAULT_ARGS -o $i && \ emerge $EMERGE_DEFAULT_ARGS -o $i && \
emerge $EMERGE_DEFAULT_ARGS $i emerge $EMERGE_DEFAULT_ARGS $i
done done
@@ -21,11 +22,11 @@ for i in $(EIX_LIMIT=0 eix --only-names --pure-packages "$SEARCH/" | xargs echo
build_installed() { build_installed() {
local SEARCH=$1 local SEARCH=$1
local EMERGE_DEFAULT_ARGS=${2:---accept-properties=-interactive --newuse --changed-use --update --verbose --oneshot --nospinner --quiet-build=y --quiet-fail --fail-clean=y --complete-graph --buildpkg} local EMERGE_DEFAULT_ARGS=${2:---accept-properties=-interactive --newuse --noreplace --changed-use --update --verbose --oneshot --nospinner --quiet-build=y --quiet-fail --fail-clean=y --complete-graph --buildpkg}
for i in $(EIX_LIMIT=0 eix -I --only-names --pure-packages "$SEARCH/" | xargs echo | uniq); for i in $(EIX_LIMIT=0 eix -I --only-names --pure-packages "$SEARCH/" | xargs echo | uniq);
do do
#emerge $EMERGE_DEFAULT_ARGS -o $i && \ echo "Building $i"
emerge $EMERGE_DEFAULT_ARGS $i emerge $EMERGE_DEFAULT_ARGS $i
done done
} }